-- Copyright (c) 2013 Cloudera, Inc. All rights reserved.
--
-- * Capture the delegation token id for audit correlation.
-- * New ACTIVITY_AUDIT table to store activity info.
-- * New ACTIVITY_LAST_POLL_TIME table to track poll time.
--

create table ACTIVITY_AUDIT (
  ID                    number(19,0) constraint NOT_NULL_ACT_AUD_ID not null,
  SERVICE_NAME          varchar2(255 char) constraint NOT_NULL_ACT_AUD_SERVICE_NAME not null,
  ACTIVITY_ID           varchar2(255 char) constraint NOT_NULL_ACT_AUD_ACTIVITY_ID not null,
  PARENT_ID             number(19,0),
  ROOT_ID               number(19,0),
  ACTIVITY_TYPE         varchar2(31 char) constraint NOT_NULL_ACT_AUD_ACTIVITY_TYPE not null,
  BEGIN_TS              number(19,0) constraint NOT_NULL_ACT_AUD_BEGIN_TS not null,
  END_TS                number(19,0),
  DELEGATION_TOKEN_ID   varchar2(255 char),
  STATUS                varchar2(31 char),
  USERNAME              varchar2(255 char),
  USER_GROUP            varchar2(255 char),
  HDFS_READ_BYTES       number(19,0),
  HDFS_WRITE_BYTES      number(19,0),

  constraint PK_ACTIVITY_AUDIT primary key (ID)
);

create index IDX_ACTIVITY_AUDIT_SERVICE on ACTIVITY_AUDIT (SERVICE_NAME);
create index IDX_ACTIVITY_AUDIT_ACTIVITY_ID on ACTIVITY_AUDIT (ACTIVITY_ID);

alter table ACTIVITY_AUDIT
  add constraint FK_ACTIVITY_AUDIT_PARENT_ID
  foreign key (PARENT_ID)
  references ACTIVITY_AUDIT (ID)
  on delete cascade
  deferrable initially immediate;

alter table ACTIVITY_AUDIT
  add constraint FK_ACTIVITY_AUDIT_ROOT_ID
  foreign key (ROOT_ID)
  references ACTIVITY_AUDIT (ID)
  on delete cascade
  deferrable initially immediate;


create table ACTIVITY_LAST_POLL_TIME (
  SERVICE_NAME          varchar2(255 char) constraint NOT_NULL_ACTLPT_SERVICE_NAME not null,
  POLL_TS               number(19,0) constraint NOT_NULL_ACTLPT_POLL_TS not null,

  constraint PK_ACTIVITY_LAST_POLL_TIME primary key (SERVICE_NAME)
);

--  Add DELEGATION_TOKEN_ID to HDFS tables
com.cloudera.navigator.schema.AddHdfsDelegationTokenId
